unit ActnListPatch;

(* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * Contributor(s):
 *   Xu, Qian <http://stanleyxu2005.blogspot.com/>
 *
 * ***** END LICENSE BLOCK ***** *)

interface

uses
  ActnList;

// Disables TxxxxAction.OnUpdate() event to be fired.
function DisableTActionOnUpdate(ActnList: TActionList): Boolean;


implementation

uses
  Windows, FastcodePatch{http://fastcode.sourceforge.net/};


procedure TContainedActionUpdateStub;
asm
  call TContainedAction.Update;
end;

type
  TContainedActionPatch = class(TContainedAction)
  public
    function Update: Boolean; override;
  end;

function TContainedActionPatch.Update: Boolean;
begin
  Result := False;
end;

function DisableTActionOnUpdate(ActnList: TActionList): Boolean;
var
  I: Integer;
begin
  Result := True;
  for I := 0 to ActnList.ActionCount - 1 do
    if Assigned(ActnList.Actions[I].OnUpdate) then
    begin
      Result := False;
      Break;
    end;

  if Result then
  begin
    FastcodeAddressPatch(
      FastcodeGetAddress(@TContainedActionUpdateStub),
      @TContainedActionPatch.Update);
  end;
end;


end.
